DefaultListAdapter (FreeMarker 2.3.35 API)
Description: declaration: package: freemarker.template, class: DefaultListAdapter

Package freemarker.template

# Class DefaultListAdapter

java.lang.Object
freemarker.template.WrappingTemplateModel
freemarker.template.DefaultListAdapter

All Implemented Interfaces:
  `WrapperTemplateModel`, `AdapterTemplateModel`, `TemplateModel`, `TemplateModelWithAPISupport`, `TemplateSequenceModel`, `Serializable`

public class DefaultListAdapter extends WrappingTemplateModel implements TemplateSequenceModel, AdapterTemplateModel, WrapperTemplateModel, TemplateModelWithAPISupport, Serializable
Adapts a `List` to the corresponding `TemplateModel` interface(s), most importantly to `TemplateSequenceModel`. If you aren't wrapping an already existing `List`, but build a sequence specifically to be used from a template, also consider using `SimpleSequence` (see comparison there).

Thread safety: A `DefaultListAdapter` is as thread-safe as the `List` that it wraps is. Normally you only have to consider read-only access, as the FreeMarker template language doesn't allow writing these sequences (though of course, Java methods called from the template can violate this rule).

This adapter is used by `DefaultObjectWrapper` if its `useAdaptersForCollections` property is `true`, which is the default when its `incompatibleImprovements` property is 2.3.22 or higher.

Since:
  2.3.22
See Also:
  `SimpleSequence`, `DefaultArrayAdapter`, `TemplateSequenceModel`, Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected List`
  `list`

  ### Fields inherited from interface freemarker.template.TemplateModel

  `NOTHING`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultListAdapter`
  `adapt​(List list, RichObjectWrapper wrapper)`
  Factory method for creating new adapter instances.
  `TemplateModel`
  `get​(int index)`
  Retrieves the i-th template model in this sequence.
  `Object`
  `getAdaptedObject​(Class hint)`
  Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.
  `TemplateModel`
  `getAPI()`
  Returns the model that exposes the (Java) API of the value.
  `Object`
  `getWrappedObject()`
  Retrieves the original object wrapped by this model.
  `int`
  `size()`

  ### Methods inherited from class freemarker.template.WrappingTemplateModel

  `getDefaultObjectWrapper, getObjectWrapper, setDefaultObjectWrapper, setObjectWrapper, wrap`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### list

    protected final List list

- ## Method Details

  - ### adapt

    public static DefaultListAdapter adapt​(List list, RichObjectWrapper wrapper)
    Factory method for creating new adapter instances.
    Parameters:
      `list` - The list to adapt; can't be `null`.
      `wrapper` - The `ObjectWrapper` used to wrap the items in the array.

  - ### get

    public TemplateModel get​(int index) throws TemplateModelException
    Description copied from interface: `TemplateSequenceModel`
    Retrieves the i-th template model in this sequence.
    Specified by:
      `get` in interface `TemplateSequenceModel`
    Returns:
      the item at the specified index, or `null` if the index is out of bounds. Note that a `null` value is interpreted by FreeMarker as "variable does not exist", and accessing a missing variables is usually considered as an error in the FreeMarker Template Language, so the usage of a bad index will not remain hidden, unless the default value for that case was also specified in the template.
    Throws:
      `TemplateModelException`

  - ### size

    public int size() throws TemplateModelException
    Specified by:
      `size` in interface `TemplateSequenceModel`
    Returns:
      the number of items in the list.
    Throws:
      `TemplateModelException`

  - ### getAdaptedObject

    public Object getAdaptedObject​(Class hint)
    Description copied from interface: `AdapterTemplateModel`
    Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.
    Specified by:
      `getAdaptedObject` in interface `AdapterTemplateModel`
    Parameters:
      `hint` - the desired class of the returned value. An implementation should make reasonable effort to retrieve an object of the requested class, but if that is impossible, it must at least return the underlying object as-is. As a minimal requirement, an implementation must always return the exact underlying object when `hint.isInstance(underlyingObject)` holds. When called with `java.lang.Object.class`, it should return a generic Java object (i.e. if the model is wrapping a scripting language object that is further wrapping a Java object, the deepest underlying Java object should be returned).
    Returns:
      the underlying object, or its value accommodated for the hint class.

  - ### getWrappedObject

    public Object getWrappedObject()
    Description copied from interface: `WrapperTemplateModel`
    Retrieves the original object wrapped by this model.
    Specified by:
      `getWrappedObject` in interface `WrapperTemplateModel`

  - ### getAPI

    public TemplateModel getAPI() throws TemplateModelException
    Description copied from interface: `TemplateModelWithAPISupport`
    Returns the model that exposes the (Java) API of the value. This is usually implemented by delegating to `ObjectWrapperWithAPISupport.wrapAsAPI(Object)`.
    Specified by:
      `getAPI` in interface `TemplateModelWithAPISupport`
    Throws:
      `TemplateModelException`